unit FreeOTFEfmeOptions_SystemTray;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, FreeOTFESettings, SDUStdCtrls,
  CommonfmeOptions_Base, FreeOTFEfmeOptions_Base;

type
  TfmeOptions_SystemTray = class(TfmeFreeOTFEOptions_Base)
    gbSystemTrayIcon: TGroupBox;
    ckUseSystemTrayIcon: TSDUCheckBox;
    ckMinToIcon: TSDUCheckBox;
    ckCloseToIcon: TSDUCheckBox;
    procedure ckUseSystemTrayIconClick(Sender: TObject);
  protected
    procedure _ReadSettings(config: TFreeOTFESettings); override;
    procedure _WriteSettings(config: TFreeOTFESettings); override;
  public
    procedure Initialize(); override;
    procedure EnableDisableControls(); override;
  end;

implementation

{$R *.dfm}

uses
  Math,
  SDUGeneral;

procedure TfmeOptions_SystemTray.ckUseSystemTrayIconClick(Sender: TObject);
begin
  inherited;
  EnableDisableControls();
end;

procedure TfmeOptions_SystemTray.Initialize();
var
  maxToIconCkBoxWidth: integer;
begin
  // ckHotkeyDismount and ckHotkeyDismountEmerg have AutoSize := TRUE
  // Use the autosized controls to determine how big the groupbox needs to be
  maxToIconCkBoxWidth := max(ckMinToIcon.width, ckCloseToIcon.width);
  gbSystemTrayIcon.width := max(
                                (ckUseSystemTrayIcon.left * 2) + ckUseSystemTrayIcon.width,
                                (ckMinToIcon.left + maxToIconCkBoxWidth + ckUseSystemTrayIcon.left)
                               );

  SDUCenterControl(gbSystemTrayIcon, ccHorizontal);
  SDUCenterControl(gbSystemTrayIcon, ccVertical, 25);
end;

procedure TfmeOptions_SystemTray.EnableDisableControls();
begin
  inherited;

  SDUEnableControl(ckMinToIcon,   ckUseSystemTrayIcon.checked);
  SDUEnableControl(ckCloseToIcon, ckUseSystemTrayIcon.checked);
end;

procedure TfmeOptions_SystemTray._ReadSettings(config: TFreeOTFESettings);
begin
  // System tray icon related...
  ckUseSystemTrayIcon.checked := config.OptSystemTrayIconDisplay;
  ckMinToIcon.checked         := config.OptSystemTrayIconMinTo;
  ckCloseToIcon.checked       := config.OptSystemTrayIconCloseTo;

end;

procedure TfmeOptions_SystemTray._WriteSettings(config: TFreeOTFESettings);
begin
  // System tray icon related...
  config.OptSystemTrayIconDisplay := ckUseSystemTrayIcon.checked;
  config.OptSystemTrayIconMinTo   := ckMinToIcon.checked;
  config.OptSystemTrayIconCloseTo := ckCloseToIcon.checked;

end;

END.

